-- Simple and experimental port of explorer ONEmenu...
files.mkdir("ux0:/ONEMENU/")
pathini="ux0:/ONEMENU/ONEMENU.INI"

mimes = image.load("app0:/SAMPLES/ICONS.PNG",16,16)--Sprites icons
total_scan = 0

function write_table(pathini, tb)
    local file = io.open(pathini, "w+")
	file:write("config = {\n")
	for s,t in pairs(tb) do
		if type(t) == "string" then
			file:write(string.format('"%s",\n', tostring(t)))
		else
			file:write(string.format('%s,\n', tostring(t)))
		end
	end
	file:write("}")
	file:close()
end

function write_table_sfo(pathini, tb)
    local file = io.open(pathini, "w+")
	file:write("config = {\n")
	for s,t in pairs(tb) do
		if type(t) == "string" then
			file:write(string.format('"%s - %s",\n',tostring(s), tostring(t)))
		else
			file:write(string.format('"%s - %s",\n',tostring(s), tostring(t)))
		end
	end
	file:write("}")
	file:close()
end

function write_table_scan(pathini, tb)
    local file = io.open(pathini, "w+")
	file:write("scan = {\n")
	file:write(string.format('"Total - %s",\n', #tb))

	for i=1,#tb do
		file:write(string.format('"%s - %s - %s",\n',tb[i].name, tb[i].size, tb[i].pos))
	end
	file:write("}")
	file:close()
end

--1 CustomColor 2 Background
config = {0xffffff,"app0:/BACK.PNG"}

if files.exists(pathini) then
	dofile(pathini)
else
	write_table(pathini, config)
end

back2 = image.load(config[2])
if not back2 then back2=image.load("app0:/BACK.PNG") end

if back2 and (image.getrealw(back2) < __DISPLAYW or image.getrealh(back2) < __DISPLAYH) then back2:resize(__DISPLAYW, __DISPLAYH) end

selection,cancel = "cross","circle"
if buttons.assign()==0 then selection,cancel = "circle","cross" end

BarColor = color.new(0,255,0,95)

--Texts (translate)
if buttons.assign() then _button = "X" else _button = "O" end

function save_config()
	write_table(pathini, config)
end

strings = {

--Options
yes="Yes",
no="No",
up="Up",
down="Down",

--Optios Menu Explorer
back=" Return ",
copyfile="Copying File : ",
delfile="Deleting File : ",
label="Waiting...\nLoading Image...",
background="Background: Press Triangle",
dir="<DIR>",
copy = "Copy",
delete = "Delete ",
makedir = "MakeDir",
rename = "Rename",
extract = "Extract",
cancel = "Cancel",
ftp = "FTP",
serverftp = "Server ftp://",
closeftp = "Press START for close conexion FTP",
loseftp = "Conexion FTP Closed",
base_headers="Headers.bin",
extractto = "Extract To",
paste = "Paste",
move = "Move",
pass="Use Pass ?",
creatfolder="Create Folder",
newfolder="New Folder",
ospass="PASS",

}

-- ## Library Scroll ## --
scroll = {}

function scroll.set(num,tab,mxn)
	scroll[num] = {ini=1,sel=1,lim=1,maxim=1}
	if #tab > mxn then scroll[num].lim=mxn else scroll[num].lim=#tab end
	scroll[num].maxim = #tab
end

function scroll.max(num,mx)
scroll[num].maxim = #mx
end

function scroll.up(num)
	if scroll[num].sel>scroll[num].ini then scroll[num].sel-=1
	elseif scroll[num].ini-1>=1 then
		scroll[num].ini,scroll[num].sel,scroll[num].lim=scroll[num].ini-1,scroll[num].sel-1,scroll[num].lim-1
	end
end

function scroll.down(num)
	if scroll[num].sel<scroll[num].lim then scroll[num].sel+=1
	elseif scroll[num].lim+1<=scroll[num].maxim then
		scroll[num].ini,scroll[num].sel,scroll[num].lim=scroll[num].ini+1,scroll[num].sel+1,scroll[num].lim+1
	end
end

-- ## Muestra Un texto mientras algo se carga 'LABEL' ## --
function label(txt) -- mensaje de loading resource
	local scrback = screen.buffertoimage()
	draw.fillrect(180,100,120,72,color.new(128,128,128,150))
	draw.rect(180,100,120,72,color.black)
	screen.print(240,120,txt,0.6,color.white)--,color.black,512)
	screen.flip()
	scrback:blit(0,0)
end

-- ## Visor De imagenes ## --
function visorimg(path) -- Version simplificada del visor del shell
	collectgarbage("collect")
	os.delay(5)
	local scrback = screen.buffertoimage()
	label(strings.label)
	local tmp = image.load(path)
	if tmp then
		local infoimg = {}
		infoimg.name = files.nopath(path)
		infoimg.w,infoimg.h = image.getrealw(tmp),image.getrealh(tmp)
		local show_bar_upper = true
		tmp:center()

		bar=40
		if infoimg.w==__DISPLAYW and infoimg.h==__DISPLAYH then bar=50 end
		for i=0,bar,2 do
			tmp:blit(__DISPLAYW/2,__DISPLAYH/2)
			draw.fillrect(0,0,__DISPLAYW,i,color.new(255,255,255,100))
			screen.flip() 
		end

		while true do
			buttons.read()
			tmp:blit(__DISPLAYW/2,__DISPLAYH/2)
			if show_bar_upper then
				draw.fillrect(0,0,__DISPLAYW,bar,color.new(255,255,255,100))

				screen.print(10,5,infoimg.name,0.9,color.white,color.black)
				screen.print(800,5,"w:"..infoimg.w,0.9,color.white,color.black,__ARIGHT)
				screen.print(900,5,"h:"..infoimg.h,0.9,color.white,color.black,__ARIGHT)

				if (infoimg.w>500 and infoimg.w <= __DISPLAYW) and (infoimg.h>300 and infoimg.h<=__DISPLAYH) then
					screen.print(10,15,strings.background,0.6,color.white,color.black)
				end
			end
			screen.flip()

			if buttons.square then show_bar_upper = not show_bar_upper end

			if buttons.triangle then
				if (infoimg.w>500 and infoimg.w <= __DISPLAYW) and (infoimg.h>300 and infoimg.h<=__DISPLAYH) then
					back2 = image.load(path)
					if back2 then 
						config[2] = path
						back2:resize(__DISPLAYW, __DISPLAYH)
						save_config()
					end
				end
			end

			if buttons[cancel] or buttons[selection] then
				break
			end
		end

		if show_bar_upper then
			for i=bar,0,-2 do
				tmp:blit(__DISPLAYW/2,__DISPLAYH/2)
					draw.fillrect(0,0,__DISPLAYW,i,color.new(255,255,255,100))
				screen.flip() 
			end
		end

		tmp = nil
		collectgarbage("collect")
		os.delay(5)
	end
	scrback:blit(0,0)
end

--[[
	=======================
	Funciones de extraccion
	=======================
]]

-- CallBack Extraction
function onExtractFiles(size,written,file,totalsize,totalwritten)

	if back2 then back2:blit(0,0) end
	draw.fillrect(0,0,__DISPLAYW,30, BarColor)

	screen.print(10,10,"Extraction...")
	screen.print(10,30,"File: "..tostring(file))
	screen.print(10,50,"Percent: "..math.floor((written*100)/size).."%")
	screen.print(10,70,"Percent Total: "..math.floor((totalwritten*100)/totalsize).."%")
	screen.print(10,90,"Total Size: "..tostring(totalsize).." Total Written: "..tostring(totalwritten))

	screen.flip()
	
	buttons.read()
	if buttons.circle then
		return 0;
	end
	return 1;
end

function onInstallApps(size,written,name,totalsize,totalwritten)
	if back then back:blit(0,0) end
	screen.print(10,10,"Descomprimiendo APP...")
	screen.print(10,30,"File: "..tostring(name))
	screen.print(10,50,"Percent: "..math.floor((written*100)/size).."%")
	screen.print(10,70,"Percent Total: "..math.floor((totalwritten*100)/totalsize).."%")
	screen.print(10,90,"Total Size: "..tostring(totalsize).." Total Written: "..tostring(totalwritten))
	draw.fillrect(0,520,((written*960)/size),20,color.new(0,255,0))
	screen.flip()

	buttons.read()
	if buttons.circle then
		return 0;
	end
	return 1;
end

function onScanningFiles(file,unsize,position)

	if back2 then back2:blit(0,0) end
	draw.fillrect(0,0,__DISPLAYW,30, BarColor)

	screen.print(10,10,"Scanning...")
	screen.print(10,30,"File: "..tostring(file))
	screen.print(10,50,"Size Unpack: "..tostring(unsize))
	screen.print(10,70,"Offset: "..tostring(position))

	screen.flip()
end

 -- CallBack CopyFiles
function onCopyFiles(size,written,file)
    if back2 then back2:blit(0,0) end
    draw.fillrect(0,0,__DISPLAYW,30, BarColor)

    porcentaje=math.floor(written*(100)/size)

    screen.print(15,5,strings.copyfile,0.9,color.white)
	screen.print(15,25,file,0.9,color.white)
    screen.print(900,5,porcentaje.." % ",0.9,color.white)

    screen.flip()
end

 -- CallBack DeleteFiles
function onDeleteFiles(file)
	if back2 then back2:blit(0,0) end
	draw.fillrect(0,0,__DISPLAYW,30, BarColor)

    screen.print(15,5,strings.delfile,0.9,color.white)
	screen.print(15,25,file,0.9,color.white)

	os.delay(10)
	screen.flip()
end

-- ## File Size Format 'B,KB,MB,GB' ##
function files.sizeformat(bytes) -- Add files module function, esta retorna el size en unidad 
	local u,c = {"B","KB","MB","GB"},1
	while bytes>1024 do
		bytes/=1024
		c+=1
	end
	return string.format("%.2f "..u[c],bytes)
end

function files.listsort(path)
	local tmp1 = files.listdirs(path)
	if tmp1 then 
		table.sort(tmp1,function(a,b) return string.lower(a.name)<string.lower(b.name) end)
	else
		tmp1 = {}
	end
	local tmp2 = files.listfiles(path) 
	if tmp2 then
		table.sort(tmp2,function(a,b) return string.lower(a.name)<string.lower(b.name) end)
		for s,t in pairs(tmp2) do
			t.size = files.sizeformat(t.size)
			table.insert(tmp1,t)-- esto es por que son subtablas, realmente no puedo hacer un cont con tmp2
		end
	end
	return tmp1
end

-- ## Explorador ## --
explorer = {} -- All explorer functions
	-- index for scroll
	-- 1: List
	-- 2: Menu

-- ## Explorer Refresh ## --
function explorer.refresh()
explorer.list = files.listsort(Root[Dev]) 
scroll.set(1,explorer.list,20)
end

icons={1,pbp=2,prx=2,
png=3,gif=3,jpg=3,bmp=3,
mp3=4,s3m=4,wav=4,at3=4,
rar=5,zip=5,vpk=5,
cso=6,iso=6,dax=6
}

-- ## Explorer Drawer List ## --
function explorer.listshow()
	local h=27
	for i=scroll[1].ini,scroll[1].lim do
		if i==scroll[1].sel then draw.fillrect(0, h-1, __DISPLAYW, 20, color.new(0,255,0,100)) end

		if explorer.list[i].size then
			if icons[explorer.list[i].ext] then mimes:blitsprite(5,h, icons[explorer.list[i].ext])
			else mimes:blitsprite(5,h, 0) end
		else
			mimes:blitsprite(5,h, 1)
		end

		screen.print(25, h, explorer.list[i].name or "",1.1, isopened[explorer.list[i].ext] or color.white, color.black)
		screen.print(760, h, explorer.list[i].size or strings.dir, 1.1, color.white, color.black, __ARIGHT)
		h+=22
	end
end

-- ## Explorer Drawer Menu ## --
function explorer.menushow()
	local h = slide_y + 5
	local i = scroll[2].ini
	while i <= scroll[2].lim do
		if i==scroll[2].sel then cc=color.new(255,130,0) else cc=color.white end
		screen.print(slide_x,h,slide_opts_txt[i],1,cc)--,color.black,512)
		h,i=h+15, i+1
	end
end


isopened = { png = color.green, jpg = color.green, gif = color.green, bmp = color.green,
pmf=color.blue, iso = color.orange, pbp = color.orange, cso = color.orange, dax = color.orange, zip = color.red, rar = color.red,
vpk = color.yellow }

function copysrc()
	explorer.src = explorer.list[scroll[1].sel].path
	explorer.action = scroll[2].sel
	slide_open[2]=false
	scroll.set(2,slide_opts_txt,9)
end

function update_opts_txt()
	explorer.refresh()
	slide_opts_txt = {strings.copy,strings.move,strings.extract,strings.delete,strings.makedir,strings.rename,strings.ftp,
	strings.base_headers,strings.cancel}
	scroll.set(2,slide_opts_txt,#slide_opts_txt)
	explorer.action = 0
	explorer.src, explorer.dst = "",""
end

function explorer.main()
	buttons.analogtodpad(0)
	Root = {"ux0:/","app0:/"}
	Dev=1
	backl,slide_open = {},{false,false}
	slide_x,slide_y,slide_h = 400,122,0
	update_opts_txt()
	divsect = 1
	buttons.interval(8,8)
	
	while true do
		buttons.read()
		if back2 then back2:blit(0,0) end
	
		if divsect == 1 then -- List
			show_explorer_list() -- regla siempre el draw
			ctrls_explorer_list()
			if buttons.triangle then
				BackExpl = screen.buffertoimage()
				divsect, slide_open = 2, {true,true}
			end
		elseif divsect == 2 then -- Menu
			if BackExpl then BackExpl:blit(0,0) end
			show_explorer_menu() -- correccion igual para el draw list
			if slide_h > 100 then ctrls_explorer_menu() end -- evita uso de controles si se esta abriendo o cerrando
			if buttons.triangle or buttons[cancel] then slide_open[2]=false end
		end

		screen.flip()

		if buttons.start and not slide_open[2] then -- Salimos del explorer
			explorer.list=nil
			break
		end
	end
	buttons.analogtodpad(60)
end

function show_msg_pbp(path)
	local bufftmp = screen.buffertoimage()
	local x,y = (960-420)/2,(544-420)/2

	local icon0PBP = game.geticon0(path)
	local sfoPBP = game.info(path)

	local res = false
	while true do
		bufftmp:blit(0,0)

		draw.fillrect(x,y,420,420,color.shine)
		draw.rect(x,y,420,420,color.white)
		screen.print(960/2,y+15,"Desea iniciar este PBP?",1,color.black,color.blue,__ACENTER)
		screen.print(960/2,y+30,tostring(sfoPBP.TITLE),1,color.black,color.blue,__ACENTER)
		
		if icon0PBP then
			icon0PBP:bilinear()
			icon0PBP:scale(200)
			icon0PBP:center()
			icon0PBP:blit(960/2,544/2)
		end

		screen.print(960/2,y+400,"X: Accept  |  O: Cancel",1,color.black,color.blue,__ACENTER)
		screen.flip()

		buttons.read()
		if buttons.cross or buttons.circle then
			res = buttons.cross
			break
		end
		
	end
	bufftmp:blit(0,0)
	buttons.read()--flush xD
	return res
end

function show_msg_vpk(path)
	local bufftmp = screen.buffertoimage()
	local x,y = (960-420)/2,(544-420)/2
	
	scan = files.scan(path)

	ebootbin,icon,sfo=-1,-1,-1
	if scan then
		for i=1,#scan do
			if scan[i].name:lower() == "sce_sys/icon0.png" then icon = scan[i].pos
			elseif scan[i].name:lower() == "sce_sys/param.sfo" then sfo = scan[i].pos
			elseif scan[i].name:lower() == "eboot.bin" then ebootbin = scan[i].pos end
		end
	end

	if ebootbin != -1 then total_access = files.checkvpk(path,ebootbin) else total_access = files.checkvpk(path) end
	if icon != -1 then icon0vpk = game.geticon0(path, icon) else icon0vpk = game.geticon0(path) end
	if sfo != -1 then sfoPVK = game.info(path, sfo) else sfoPVK = game.info(path) end

	write_table_sfo("ux0:/debugsfovpk.txt", sfoPVK)
	write_table_scan("ux0:/debugscan.txt", scan)

	local res = false
	local realsize = files.sizeformat(scan.realsize or 0)
	while true do
		bufftmp:blit(0,0)
		draw.fillrect(x,y,420,420,color.shine)
		draw.rect(x,y,420,420,color.black)
		screen.print(960/2,y+7,"Desea instalar este VPK?",1,color.black,color.blue,__ACENTER)
	
		if sfoPVK then
			screen.print(960/2,y+26,tostring(sfoPVK.TITLE),1,color.black,color.blue,__ACENTER)
			screen.print(960/2,y+45,tostring(sfoPVK.TITLE_ID),1,color.black,color.blue,__ACENTER)
		end
		screen.print(960/2,y+62,"Total Access VPK: "..tostring(total_access),1,color.black,color.blue,__ACENTER)
		screen.print(960/2,y+80,"Total Size VPK: "..tostring(realsize),1,color.black,color.blue,__ACENTER)
		
		if icon0vpk then
			icon0vpk:bilinear()
			icon0vpk:scale(150)
			icon0vpk:center()
			icon0vpk:blit(960/2,544/2)
		end

		screen.print(960/2,y+400,"X: Accept  |  O: Cancel",1,color.black,color.blue,__ACENTER)
		screen.flip()
		buttons.read()


		if buttons.triangle then screen.shot("ux0:/myscreenshot.png") end
		if buttons.cross or buttons.circle then
			res = buttons.cross
			break
		end
		
	end
	bufftmp:blit(0,0)
	buttons.read()--flush xD
	return res
end

function ctrls_explorer_list()

	if buttons[cancel] then -- return directory
		Root[Dev]=files.nofile(Root[Dev])
		explorer.refresh()
		if #backl>0 then
			if scroll[1].maxim == backl[#backl].maxim then
				scroll[1]=backl[#backl]
			end
			backl[#backl] = nil
		end
	end

	if scroll[1].maxim > 0 then												-- Is exists any?
		if buttons.up or buttons.held.l or buttons.analogly < -60 then scroll.up(1) end
		if buttons.down or buttons.held.r or buttons.analogly > 60 then scroll.down(1) end

		if buttons[selection] then
			local extension = explorer.list[scroll[1].sel].ext
			if extension == "png" or extension == "jpg" or extension == "gif" or extension == "bmp" then
				visorimg(explorer.list[scroll[1].sel].path)
			elseif extension == "vpk" then
				if show_msg_vpk(explorer.list[scroll[1].sel].path) then
					local crono = timer.new()
					crono:start()
					result = files.install(explorer.list[scroll[1].sel].path, scan.realsize)
					crono:stop()
					timeused= crono:time()/1000
				end
			elseif extension == "pbp" then
				show_msg_pbp(explorer.list[scroll[1].sel].path)
			end

			extension=nil
			if not explorer.list[scroll[1].sel].size then 					-- Its Dir
				table.insert(backl,scroll[1])
				Root[Dev]=explorer.list[scroll[1].sel].path
				explorer.refresh()
			end
		end

	end

	if buttons.select and not slide_open[2] then								-- Switch device
		if Dev == 1 and files.exists("app0:/") then
			Dev = 2
			explorer.refresh()
		elseif Dev == 2 and files.exists("ux0:/") then
			Dev = 1
			explorer.refresh()
		end
	end
end

function show_explorer_list()
	screen.print(5,5,Root[Dev],1,color.new(255,69,0),color.black)
	screen.print(900,5,#explorer.list,1,color.new(255,69,0),color.black,__ARIGHT)
	if scroll[1].maxim > 0 then 
		if scroll[1].maxim> 15 then -- Draw Scroll Bar
			local pos_height = math.max(436/scroll[1].maxim, 15)
			draw.fillrect(920, 27, 8, 436, color.new(255,255,255,100))
			draw.fillrect(920, 27+((436-pos_height)/(scroll[1].maxim-1))*(scroll[1].sel-1), 8, pos_height, color.new(0,255,0))
		end
		explorer.listshow()
	else
		screen.print(10,25,"...".."\n"..strings.back,1.1,color.white,color.black)
	end
	screen.print(12,500,explorer.src or "",0.9,color.new(255,69,0),color.black)
	screen.print(12,525,"Extracción/Instalacion vpk: "..(result or "").." tiempo (s) utilizado: "..tostring(timeused),1,color.black,color.white)
end

function show_explorer_menu()
	if slide_open[2] and slide_h < 110 then slide_h+=8 end
	if not slide_open[2] and slide_h > 0 then slide_h-=8 end
	if not slide_open[2] and slide_h < 2 then slide_open[1] = false end
	if not slide_open[1] and slide_h < 2 then divsect = 1 end
	draw.fillrect(slide_x-3,slide_y,120,slide_h+33,color.new(255,255,255,100))
	if slide_h > 100 then explorer.menushow() end -- la pongo aqui pues de lo contrario no actuan los if
end

function ctrls_explorer_menu()

	if buttons.up or buttons.held.l then scroll.up(2) end
	if buttons.down or buttons.held.r then scroll.down(2) end

	if buttons[selection] then
		local numerador = 0
		if explorer.src == "" and scroll[2].sel <= 3 then
			if #explorer.list > 0 then
				if scroll[2].sel == 1 or scroll[2].sel == 2 then			--Copy/Move
					slide_opts_txt = {strings.paste,strings.delete,strings.makedir,strings.rename,strings.ftp,strings.base_headers,strings.cancel}
					copysrc()
				else														--Extract
					if explorer.list[scroll[1].sel].ext and (files.ext(explorer.list[scroll[1].sel].path):upper()=="ZIP" or
						files.ext(explorer.list[scroll[1].sel].path):upper()=="RAR") then
							slide_opts_txt = {strings.extractto,strings.delete,strings.makedir,strings.rename,strings.ftp,strings.base_headers,strings.cancel}
							copysrc()
					end
				end
			end--#explorer.list > 0
		elseif string.len(explorer.src) > 0 then
			if scroll[2].sel == 1 then
				explorer.dst = Root[Dev]
				screen.print(12,257,explorer.dst or "",0.9,color.new(255,69,0),color.black)
				if explorer.action == 1 then								--Paste from Copy
					files.copy(explorer.src,explorer.dst)
				elseif explorer.action == 2 then							--Paste from Move
						files.move(explorer.src,explorer.dst)
				elseif explorer.action == 3 then							--Extract
					if os.message(strings.pass,1) == 1 then
						local pass = osk.init(strings.ospass,"")
						if pass then files.extract(explorer.src,explorer.dst,pass) end
					else
						result = files.extract(explorer.src,explorer.dst)
					end
				end
				slide_open[2]=false
				update_opts_txt()
			end
			numerador = 2
		end -- end of string len

		if scroll[2].sel == (4 - numerador) and #explorer.list > 0 then		--Delete
			if os.message(strings.delete..explorer.list[scroll[1].sel].name.." ?",1) == 1 then
				files.delete(explorer.list[scroll[1].sel].path)
				slide_open[2]=false
				update_opts_txt()
			end
		end
		if scroll[2].sel == (5 - numerador) then							--MakeDir
			local newfolder = osk.init(strings.creatfolder, strings.newfolder)
			if newfolder then
				local dest = Root[Dev].."/"..newfolder
				if Root[Dev]:sub(#Root[Dev]) == "/" then dest = Root[Dev]..newfolder end
				files.mkdir(dest)
				slide_open[2]=false
				update_opts_txt()
			end
		end
		if scroll[2].sel == (6 - numerador) and #explorer.list > 0 then		--Rename
			local name = osk.init(strings.rename,files.nopath(explorer.list[scroll[1].sel].path))
			if name then
				files.rename(explorer.list[scroll[1].sel].path, name)
				slide_open[2]=false
				update_opts_txt()
			end
		end

		if scroll[2].sel == (7-numerador) then								--FTP
			if not wlan.isconnected() then wlan.connect() end
			if wlan.isconnected() then ftp.init() end
			--ftp.init()
			while ftp.state() do
				buttons.read()
				if back2 then back2:blit(0,0) end
				screen.print(5,5,strings.serverftp..tostring(wlan.getip()),1,color.new(255,69,0),color.black)
				screen.print(5,25,strings.closeftp,1,color.new(255,69,0),color.black)
				screen.flip()

				if buttons.start then
					if back2 then back2:blit(0,0) end
					screen.print(5,5,strings.serverftp..tostring(wlan.getip()),1,color.new(255,69,0),color.black)
					screen.print(5,25,strings.closeftp,1,color.new(255,69,0),color.black)
					screen.print(5,45,strings.loseftp,1,color.new(255,69,0),color.black)
					screen.flip()
					ftp.term()
					buttons.waitforkey()
				end
			end
			--os.delay(1000)
		end

		if scroll[2].sel == (9-numerador) then								--Cancel
			slide_open[2]=false
			update_opts_txt()
		end

	end--if buttons[selection]
end

explorer.main()
