-- Oficial ONElua Tester Modules
splash.show()
splash.gekihen()
color.loadpalette()
color.shine = color.new(255,255,255,100) -- new color shine!
back = image.load("app0:/back.png")
modulos = {"batt","buttons","color","draw","ftp","ini","http","socket","image","sprite","maps","os","power","hardware","wlan","explorer"}
labels = {
	"Module Battery Manager",
	"Module Buttons, touch and joys Manager",
	"Module Colors Manager",
	"Module Drawing shapes Manager",
	"Module Server FTP Manager",
	"Module Ini Manager",
	"Module Http Manager",
	"Module Socket Manager",
	"Module Texture 2D Manager",
	"Module Sprites 2D Manager",
	"Module Maps 2D Manager",
	"Module OS Manager",
	"Module Power Manager",
	"Module Hardware Manager",
	"Module NET Manager",
	"Module Files Manager",
}

over = 1
buttons.interval(10,10)
buttons.analogtodpad(60)
while true do
	if back then back:blit(0,0) end
	buttons.read()
	screen.print(480,10,"Oficial ONEluaVita Tester Modules",1,color.white,color.blue,__ACENTER) -- Titulo
	for i=1,#modulos do
		if i == over then screen.print(10,30+(20*i-1),"->")	end
		screen.print(40,30+(20*i-1),modulos[i])
	end

	draw.fillrect(380,420,570,110,color.shine)
	draw.rect(380,420,570,110,color.white)
	screen.print(390,430,"Module Description:")
	screen.print(390,450,labels[over] or "No label..")

	if buttons.up then over -= 1 elseif buttons.down then over += 1 end
	if over < 1 then over = #modulos elseif over > #modulos then over = 1 end

	screen.print(10,500,"app0:/samples/"..modulos[over]..".lua")
	screen.print(10,520,"Touch: "..string.format("x: %03d - y: %03d",buttons.touchf[1].x,buttons.touchf[1].y))
	screen.print(buttons.touchf[1].x, buttons.touchf[1].y, "+")
	screen.print(840,10,os.date("%I:%M %p"))
	screen.flip()

	if buttons.cross then if files.exists("app0:/samples/"..modulos[over]..".lua") then dofile("app0:/samples/"..modulos[over]..".lua") end end
end