color.loadpalette() -- Load Defaults colors
mask = {"up", "down", "left", "right", "cross", "circle", "square", "triangle", "r", "l", "start", "select"}

function draw.rectHighlight(x, y, w, h,color_in,color_line)
	if not color_in then color_in = color.shine end
	if not color_line then color_line = color.white end
	draw.fillrect(x, y, w, h, color_in); draw.rect(x, y, w, h, color_line)
end

released_alfa = 0
released_msg = ""

press_alfa = 0
press_msg = ""

touch_alfa_top = {0,0,0,0,0,0}
touch_alfa_back = {0,0,0,0,0,0}
touch_col = {color.white, color.green, color.blue, color.red, color.yellow, color.orange, color.cyan}

while true do
	if back then back:blit(0,0) end

	buttons.read() -- Read Buttons :P

	draw.rectHighlight(200,10,320,30)
	screen.print(205,15,"Buttons Tester ONElua Sample",1,color.white)
	
	draw.rectHighlight(200,430,300,100)
	screen.print(210,430,"Pressed Test Area",1,color.white)
	screen.print(210,475,"Released Test Area",1,color.white)
	
	draw.rectHighlight(10,10,180,530)
	screen.print(15,12,"Held Test Area",1,color.white)
	
	local x = 20
	local y = 40
	for i=1,#mask do
		if buttons.held[mask[i]] then
			screen.print(x,y,mask[i].." Held!",1.0,color.white)
			y += 20
		end
		if buttons[mask[i]] then
			press_alfa = 255
			press_msg = mask[i].." Press!"
		end
		if buttons.released[mask[i]] then
			released_alfa = 255
			released_msg = mask[i].." released!"
		end
	end
	
	screen.print(210,455,press_msg,1,color.white:a(press_alfa))
	if press_alfa > 0 then press_alfa -= 4 end
	
	screen.print(210,495,released_msg,1,color.white:a(released_alfa))
	if released_alfa > 0 then released_alfa -= 4 end
	
	screen.print(600,10,"Touch: "..string.format("x: %03d - y: %03d - moved: %s",buttons.touchf[1].x,buttons.touchf[1].y,tostring(buttons.touchf[1].moved)))
	screen.print(600,30,"Analog Left: "..string.format("x: %03d - y: %03d",buttons.analoglx,buttons.analogly))
	screen.print(600,50,"Analog Right: "..string.format("x: %03d - y: %03d",buttons.analogrx,buttons.analogry))

	for i=1,6 do
		screen.print(buttons.touchf[i].x,buttons.touchf[i].y, "+",1,touch_col[i]:a(touch_alfa_top[i]))
		if buttons.touchf[i].moved then
			touch_alfa_top[i] = 255
		elseif touch_alfa_top[i] > 0 then
			touch_alfa_top[i] -= 2
		end
	end

	for i=1,4 do
		screen.print(buttons.touchb[i].x,buttons.touchb[i].y, "X",1,touch_col[i]:a(touch_alfa_back[i]))
		if buttons.touchb[i].moved then
			touch_alfa_back[i] = 255
		elseif touch_alfa_back[i] > 0 then
			touch_alfa_back[i] -= 2
		end
	end

	screen.flip() -- Show Buff

	if buttons.released.start then break end -- back to main.

end
